package web.multitask.trismegistoservices.service;


import com.itextpdf.html2pdf.ConverterProperties;
import com.itextpdf.html2pdf.HtmlConverter;
import com.itextpdf.html2pdf.resolver.font.DefaultFontProvider;
import org.json.JSONArray;
import org.springframework.core.io.ByteArrayResource;
import org.springframework.stereotype.Service;

import java.io.File;
import java.io.FileOutputStream;

@Service
public class PDFService {

    public ByteArrayResource htmlToPdf(String html){
        try{
        byte[] pdfBytes = generatePdf(html);
        return new ByteArrayResource(pdfBytes);
        } catch (Exception e) {
            System.out.println(e.getMessage());
            return null;
        }
    }

    private byte[] generatePdf(String htmlContent) throws Exception {
        ConverterProperties properties = new ConverterProperties();
        DefaultFontProvider fontProvider = new DefaultFontProvider(false, false, false);
        fontProvider.addFont("/fonts/Roboto-Regular.ttf");
        properties.setFontProvider(fontProvider);
        FileOutputStream outputStream = new FileOutputStream("/var/www/html/pdf.pdf");
        HtmlConverter.convertToPdf(htmlContent, outputStream, properties);
        File file = new File("/var/www/html/pdf.pdf");
        return org.apache.commons.io.FileUtils.readFileToByteArray(file);
    } 

    private JSONArray pdfToBase64(String pdf){
        try{
            byte[] pdfBytes = generatePdf(pdf);
            return new JSONArray(pdfBytes);
            } catch (Exception e) {
                System.out.println(e.getMessage());
                return null;
            }
    }
}